con

  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

  MS_001   = 80_000_000 / 1_000

var

  long  size
  word  buf1[520], chkbuf[36], chksum  
  byte  mount, ropen, wopen, close, stop, mackflag, pollflag, resetflag, sackflag, flag, i, n
                
obj

  term   : "fullduplexserialplus"                       ' for terminal output

pub main  | d

  term.start(31, 30, %0000, 115_200)                    ' start terminal (use PST)
  
  pause(1000)
  
  term.tx(0)

  pause(1000)
     
  term.str(@version)
    
  repeat
    d := term.rxcheck
    case d
      "s": show_data
      "m": testing
      "c": clear_screen
      "p": testing2
      
pub clear_screen

  term.tx(0)
  term.tx(13)
  
pub show_data | x

  term.tx(13)
  term.tx(13)

  repeat x from 0 to 255
    repeat 8
      term.str(string("(")) 
      term.dec(x)
      term.str(string(")"))
      term.hex(data[x], 3)  
      term.tx(32)
      x++
    x--  
    term.tx(13)
  
  term.tx(13)
    
pub testing2 | chk, d, t, h

  i         := 0
  n         := 0
  chksum    := 0

  term.tx(13)                                           ' Move down 1 line
  
  repeat  i from 0 to 127                               ' Main loop. Cycle through xxx words from dat section
    if (data[i] & $0F00) == $0100                       ' Check for Command and Slave ACK
      if data[i] == $0100                               ' Slave ACK found
        term.hex(data[i], 3)                            ' Print Slave ACK
        i++                                             ' Increment index
        if data[i] == $0000                             ' Check for Master ACK
          term.tx(58)                                   ' Master ACK found print colon
          term.hex(data[i], 3)                          ' Print Master ACK
          quit                                          ' Need to quit to main repeat loop
        else                                            ' If no Master ACK such as in Slave reset
          i--                                           ' Decrement index
          term.tx(13)                                   ' Print carriage return
          quit                                          ' Need to quit to main repeat loop
      term.hex(data[i], 3)                              ' Print Master command
      term.tx(32)                                       ' Print space
      repeat                                            ' Repeat to look for rest of Master command
        chksum += data[i]                               ' Add word to checksum
        i++                                             ' Increment index
        n++                                             ' Increment N counter  
        if data[i] ==(chksum & $00FF)                   ' Check for Command checksum
          repeat n                                      ' Print N times
            term.hex(data[i], 3)                        ' Print checksum
            term.tx(32)                                 ' Print space  
          term.tx(58)                                   ' Print colon
          chksum := $0000                               ' Clear checksum
          n := 0                                        ' Reset N counter
          quit                                          ' Need to quit to main repeat loop
        else                                            ' If checksum does not match data
          i--                                           ' Decrement index  
          n := 0                                        ' Reset N counter
          if data[i] == $000                            ' Check for Master ACK was printed so print
            term.tx(13)                                 ' Master ACK was printed so print carriage return
          quit                                          ' Need to quit to main repeat loop  
    repeat                                              ' Collecting additional data from Master
      chksum += data[i]                                 ' Add word to checksum
      i++                                               ' Increment index
      n++                                               ' Increment N counter
      if (data[i] & $00FF) ==chksum                     ' Looking for checksum match
        chksum := $0000                                 ' Clear checksum 
        i := i - n                                      ' Preset index counter 
        if data[i] == $0100                             ' Look for Slave ACK
          term.hex(data[i], 3)                          ' Print data from Slave such as from Reader Just Reset
          term.tx(32)                                   ' Print space
          quit                                          ' Need to quit to main repeat loop
        repeat n + 1                                    ' Repeat printing of data N + 1 times
          term.hex(data[i], 3)                          ' Print Slave data
          term.tx(32)                                   ' Print space  
          i++                                           ' Increment index
        n := 0                                          ' Reset N counter  
        quit                                            ' Need to quit to main repeat loop         


  
    
pub testing | chk, d, t, h

  i         := 0
  h         := 0
  t         := 0
  n         := 0
  flag      := 0
  chksum    := 0 
  mackflag  := 0
  pollflag  := 0
  sackflag  := 0
  resetflag := 0

  term.tx(13)

  repeat i from 0 to 255                               ' size - 1  <- this is for direct card read bufsdw
'    term.tx(40)
'    term.dec(i)
'    term.tx(41)
'    term.tx(32)
    d := (data[i] & $FFF)                               ' Temporary- needed to strip off leading Fxxx
    case d
    
      $0000:
        if mackflag == 1
'          term.str(string("?M "))  
          term.hex(d, 3)
          term.tx(13)
          term.tx(13)
          mackflag := 0       

      $0100:
        if pollflag == 1
'          term.str(string("?P ")) 
          term.hex(d, 3)
          term.tx(13)
          term.tx(13)
          pollflag := 0 
        if sackflag == 1
'          term.str(string("?S ")) 
          term.hex(d, 3) 
          term.tx(13)
          term.tx(13)
          sackflag := 0
        if resetflag == 1
'          term.str(string("?R ")) 
          term.hex(d, 3)
          term.tx(13)
          term.tx(13)
          resetflag := 0   
        
      $0108:
        chksum := 0
        resetflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            resetflag := 1
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            quit
          next   

      $0109:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            pollflag := 1                               
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 23
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == $100
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  pollflag := 0
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  term.str(string(" NACK "))  
                  term.tx(13)
                quit
          quit
      
      $010A:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 27
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == $100
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  term.str(string(" NACK "))  
                  term.tx(13)
                quit
          quit

      $010B:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 27
              d := data[i]
              i++
              n++
              chksum += d
              if (data[i] & $F00) == ($100 & $F00)    
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  'i := i - (n + 1)
                  i -= (n + 1)
                  pollflag := 1
                quit
          quit

      $010C:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 35
          d := data[i]  
          i++
          n++
          chksum += d

          if (data[i] & $F00) == $100
            i--
            chksum := (chksum - data[i])
            if (chksum & $FF) == (d & $FF)
              sackflag := 1
              chksum := 0
              i := i - (n - 1)
              repeat n 
                term.hex(data[i], 3)
                term.tx(32)
                i++
              term.tx(58)
              i--
            else
              term.str(string(" NACK "))    
              term.tx(13)
            quit
            
      $0110:
        chksum := 0
        resetflag := 0  
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            resetflag := 1
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            quit

      $0111:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 35
          d := data[i]  
          i++
          n++
          chksum += d

          if (data[i] & $F00) == $100
            i--
            chksum := (chksum - data[i])
            if (chksum & $FF) == (d & $FF)
              sackflag := 1
              chksum := 0
              i := i - (n - 1)
              repeat n 
                term.hex(data[i], 3)
                term.tx(32)
                i++
              term.tx(58)
              i--
            else
              term.str(string(" NACK "))   
              term.tx(13)
            quit
            
      $0112:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 35
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == ($100 & $F00) 
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  'i := i - (n + 1)
                  i -= (n + 1)
                  pollflag := 1
                quit
          quit

      $0113:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 10
          d := data[i]  
          i++
          n++
          chksum += d

          if (data[i] & $F00) == $100
            i--
            chksum := (chksum - data[i])
            if (chksum & $FF) == (d & $FF)
              sackflag := 1
              chksum := 0
              i := i - (n - 1)
              repeat n 
                term.hex(data[i], 3)
                term.tx(32)
                i++
              term.tx(58)
              i--
            else
              term.str(string(" NACK "))  
              term.tx(13)
            quit
            
      $0114:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 2
          d := data[i]
          chksum += d 
          i++
          n++
        d := data[i]  
        if (chksum & $FF) == (d & $FF)
          chksum := 0
          i := i - n ' - 1)
          repeat n + 1 
            term.hex(data[i], 3)
            term.tx(32)
            i++
          term.tx(58)
          d := data[i]
          if (data[i] & $0FFF) == $100
            i-- 
            sackflag := 1
          else
            term.str(string(" NACK", 13))
          next
        next
                        
      $0117:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 35
          d := data[i]  
          i++
          n++
          chksum += d

          if (data[i] & $F00) == $100
            i--
            chksum := (chksum - data[i])
            if (chksum & $FF) == (d & $FF)
              sackflag := 1
              chksum := 0
              i := i - (n - 1)
              repeat n 
                term.hex(data[i], 3)
                term.tx(32)
                i++
              term.tx(58)
              i--
            else
              term.str(string(" NACK "))  
              term.tx(13)
            quit
             
      $0130:
        chksum := 0
        resetflag := 0  
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            resetflag := 1
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            quit

      $0131:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            pollflag := 1                               ' Maybe here or in next repeat loop...
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 35
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == $100
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  pollflag := 0
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  term.str(string(" NACK "))  
                  term.tx(13)
                quit
          quit
      
      $0133:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 35
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == ($100 & $F00) 
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  'i := i - (n + 1)
                  i -= (n + 1)
                  pollflag := 1
                quit
          quit

      $0134:
        n := 0
        chksum := 0
        sackflag := 0
        repeat 35
          d := data[i]  
          i++
          n++
          chksum += d

          if (data[i] & $F00) == $100
            i--
            chksum := (chksum - data[i])
            if (chksum & $FF) == (d & $FF)
              sackflag := 1
              chksum := 0
              i := i - (n - 1)
              repeat n 
                term.hex(data[i], 3)
                term.tx(32)
                i++
              term.tx(58)
              i--
            else
              term.str(string(" NACK "))  
              term.tx(13)
            quit
            
      $0136:
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d
          i++
          d := data[i]
          if (chksum & $FF) == d
            pollflag := 1                               ' Maybe here or in next repeat loop...
            chksum := 0 
            i--
            term.hex(data[i], 3)
            term.tx(32)
            i++
            term.hex(data[i], 3)
            term.tx(58)
            i++
            n := 0
            repeat 35
              d := data[i]  
              i++
              n++
              chksum += d
              if (data[i] & $F00) == $100
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  pollflag := 0
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  term.str(string(" NACK "))  
                  term.tx(13)
                quit
          quit
              
      $0137:
        n := 0 
        chksum := 0
        mackflag := 0
        pollflag := 0 
        repeat
          d := data[i]
          chksum += d              
          i++
          n++
          d := data[i]
          if (chksum & $FF) == d
            pollflag := 1                               ' Maybe here or in next repeat loop...
            chksum := 0 
            i := i - n
            repeat n + 1
              term.hex(data[i], 3)
              term.tx(32)
              i++
            term.tx(58)
            n := 0
            repeat 33
              d := data[i]
              i++
              n++
              chksum += d
              if (data[i] & $F00) == $100
                d := data[i]
                if (chksum & $FF) == (d & $FF)
                  mackflag := 1
                  pollflag := 0
                  chksum := 0
                  i := i - n
                  repeat n + 1
                    term.hex(data[i], 3)
                    term.tx(32)
                    i++
                  term.tx(58)
                  i--  
                else
                  term.str(string(" NACK "))  
                  term.tx(13)
                quit
            quit
            
pub index_marki
             
  term.tx(40)
  term.str(string(" I-"))
  term.dec(i)
  term.tx(41)
  term.tx(32)

pub index_markn
             
  term.tx(40)
  term.str(string(" N-"))
  term.dec(n)
  term.tx(41)
  term.tx(32)
                        
pub pause(ms) | t

  t := cnt
  repeat ms
    waitcnt(t += MS_001)

dat

version byte  "Parse_Playground5", 13, 0


data    word  $0110, $0010, $0100, $0108, $0008, $0100, $0130, $0030, $0100, $0112, $0012, $0000, $0100, $0000, $0133, $0033
        word  $0006, $0009, $010F, $0000, $0111, $0000, $0003, $0010, $0001, $0001, $0026, $0100, $010B, $000B, $000B, $010B
        word  $0000, $0131, $0031, $0001, $0000, $0001, $0000, $0064, $0002, $0000, $00C8, $0000, $0000, $00FF, $0001, $0002
        word  $0005, $000A, $0014, $00FF, $0000, $0000, $0154, $0000, $0112, $0012, $0001, $0001, $0000, $0001, $0001, $0002
        word  $0030, $000D, $0143, $0000, $0109, $0009, $0003, $0000, $0001, $0005, $0002, $0000, $000F, $0001, $0002, $0005
        word  $0014, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0136, $0000, $0137
        word  $0000, $0037, $004D, $0045, $0049, $0030, $0035, $0030, $0031, $0039, $0030, $0037, $0039, $0035, $0034, $0031
        word  $0037, $0056, $004E, $0032, $0037, $0030, $0030, $0020, $0055, $0053, $0020, $0020, $0020, $0012, $0020, $0112
        word  $0000, $0117, $0000, $0056, $0045, $0045, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030
        word  $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0030, $0031, $0032
        word  $00DA, $0100, $010A, $000A, $0000, $0000, $0015, $0018, $001F, $0000, $0000, $0000, $0000, $0000, $0000, $0000
        word  $0000, $0000, $0000, $0000, $0000, $0000, $014C, $0000, $0136, $0036, $0000, $0000, $0100, $0000, $0112, $0012
        word  $0009, $0055, $0053, $0041, $0045, $0045, $0031, $0030, $0030, $0030, $0033, $0037, $0039, $0030, $0036, $002E
        word  $0045, $0070, $006F, $0072, $0074, $0020, $0045, $0064, $0067, $0065, $0020, $0020, $0030, $0030, $01B3, $0000
        word  $010C, $0000, $00FF, $0000, $00FF, $000A, $0100, $0134, $0000, $000F, $0000, $000F, $0052, $0100, $0111, $0001
        word  $0001, $0077, $0000, $0032, $00BC, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0114, $0001, $0015, $0100
        
data1   word  $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0004, $0104, $0000, $0113, $0004, $0017, $0100, $010B
        word  $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0007, $0107, $0000, $010B, $000B, $0100, $0133, $0033, $0100
        word  $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133
        word  $0033, $0100, $0112, $0012, $0100, $010A, $000A, $0000, $0000, $0015, $0018, $001F, $0000, $0000, $0000, $0000
        word  $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $014C, $0000, $0133, $0033, $0100, $0112, $0012
        word  $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100
        word  $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112
        word  $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033
        word  $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100
        word  $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B
        word  $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012
        word  $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100
        word  $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133  
        word  $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B
        word  $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100
        word  $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112

data2   word  $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033
        word  $0100, $0112, $0012, $0100, $010A, $000A, $0000, $0000, $0015, $0018, $001F, $0000, $0000, $0000, $0000, $0000
        word  $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $014C, $0000, $0133, $0033, $0100, $0112, $0012, $0100
        word  $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B
        word  $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012
        word  $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100
        word  $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133
        word  $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B
        word  $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100
        word  $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112
        word  $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033
        word  $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100
        word  $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B
        word  $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012
        word  $0100, $010B, $000B, $0100, $0133, $0033, $0100, $0112, $0012, $0100, $010B, $000B, $0100, $0133, $0033, $0100
        word  $0112, $0012, $0100, $010A, $000A, $0000, $0000, $0015, $0018, $001F, $0000, $0000, $0000, $0000, $0000, $0000
                     